<template>
  <div class="app-container">
    <!-- 对话框(添加 / 修改) -->
    <el-dialog :title="dialogTitle" :visible.sync="dialogVisible" width="45%" v-dialogDrag append-to-body>
      <el-form ref="formRef" :model="formData" :rules="formRules" v-loading="formLoading" label-width="100px">
        <el-form-item label="标签名称" prop="labelName">
          <el-input v-model="formData.labelName" placeholder="请输入标签名称"/>
        </el-form-item>
        <el-form-item label="标签分类" prop="type">
          <el-select v-model="formData.type" placeholder="请选择标签分类">
            <el-option v-for="dict in this.getDictDatas(DICT_TYPE.DICT_BASE_LABEL_BUSI_TYPE)"
                       :key="dict.value" :label="dict.label" :value="dict.value"/>
          </el-select>
        </el-form-item>
        <el-form-item label="标签样式" prop="labelType">
          <el-select v-model="formData.labelType" placeholder="请选择标签样式">
            <el-option v-for="dict in this.getDictDatas(DICT_TYPE.DICT_BASE_LABEL_TYPE)"
                       :key="dict.value" :label="dict.label" :value="dict.value"/>
          </el-select>
           实例：<el-tag :type="formData.labelType">{{ formData.labelName }}</el-tag>
        </el-form-item>
        <el-form-item label="标签描述" prop="labelDesc">
          <el-input v-model="formData.labelDesc" placeholder="请输入标签描述"/>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm" :disabled="formLoading">确 定</el-button>
        <el-button @click="dialogVisible = false">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import * as LabelApi from '@/api/base/label';

export default {
  name: "LabelForm",
  components: {},
  data() {
    return {
      // 弹出层标题
      dialogTitle: "",
      // 是否显示弹出层
      dialogVisible: false,
      // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
      formLoading: false,
      // 表单参数
      formData: {
        id: undefined,
        labelName: undefined,
        labelDesc: undefined,
        type: undefined,
        labelType: undefined
      },
      // 表单校验
      formRules: {
        labelName: [
          {required: true, message: '请输入标签名称', trigger: 'blur'},
        ],
        type: [
          {required: true, message: '请选择标签分类', trigger: 'blur'},
        ],
        labelType: [
          {required: true, message: '请选择标签样式', trigger: 'blur'},
        ],
      },
    };
  },
  methods: {
    /** 打开弹窗 */
    async open(id) {
      this.dialogVisible = true;
      this.reset();
      // 修改时，设置数据
      if (id) {
        this.formLoading = true;
        try {
          const res = await LabelApi.getLabel(id);
          this.formData = res.data;
          this.title = "修改标签库";
        } finally {
          this.formLoading = false;
        }
      }
      this.title = "新增标签库";
    },
    /** 提交按钮 */
    async submitForm() {
      // 校验主表
      await this.$refs["formRef"].validate();
      this.formLoading = true;
      try {
        const data = this.formData;
        // 修改的提交
        if (data.id) {
          await LabelApi.updateLabel(data);
          this.$modal.msgSuccess("修改成功");
          this.dialogVisible = false;
          this.$emit('success');
          return;
        }
        // 添加的提交
        await LabelApi.createLabel(data);
        this.$modal.msgSuccess("新增成功");
        this.dialogVisible = false;
        this.$emit('success');
      } finally {
        this.formLoading = false;
      }
    },
    /** 表单重置 */
    reset() {
      this.formData = {
        id: undefined,
        labelName: undefined,
        type: undefined,
        labelDesc: undefined,
        systemCode: undefined,
      };
      this.resetForm("formRef");
    }
  }
};
</script>
